/////////////////////////////// Reposa antebrazos///////////////////////////////


////////////////// Creado por Luis Rodríguez para la Fundación ONCE - 2019 /////////////////



//Este software se distribuye bajo licencia Creative Commons - Attribution - NonCommercial - ShareAlike license.
//https://creativecommons.org/licenses/by-nc-sa/4.0/
//Este software no tiene ningún tipo de garantía y el usuario será el único responsable de su uso



//////////Este reposa antebrazos está pensado para dar un soporte adicional a los antebrazos de aquellas personas que por uno u otro motivo no tengan posibilidad de mantenerlos cuando trabajan sobre una mesa//////////


///////////////Todos los parámetros están medidos en milímetros///////////////


//////////////////////////////////////////////////////////////////////////////////////////////////////////////

////////////////////Parámetros definibles por el usuario////////////////////

/*[Parámetros de la mesa donde se va a colocar]*/

//Borde de la mesa 
Borde = "Plano";      //[Plano,Redondeado]

//Grosor de la mesa 
GrueMesa = 30;           //[10:0.1:40]


/*[Parámetros del reposa antebrazos]*/

//Si se desea que el reposa antebrazos dé un mayor acceso al cuerpo 
Escotadura = "Derecha";      //[Derecha:Derecha, Izquierda:Izquierda, Sin:Sin escotadura]

//Profundidad total del reposa antebrazos
ProfTotal = 245;          //[190:5:300]

//Parte voladiza del reposa antebrazos (donde realmente se hace el apoyo)
ProfVol = 160;           //[100:5:210]

//Anchura del reposa antebrazos
AnchoTotal = 200;        //[150:1:250]

//Grosor sobre la mesa
GrueSoMesa = 5;           //[4:0.5:10]


//Grosor mínimo de la parte inferior  
GrosMinInf = 6;          //[4:0.5:10]

//Grosor máximo de la parte inferior (Valor entre 6 y 35)
GrosMaxInf = 10;         //[6:0.5:30]

//Redondeo que se desea para el hueco de la escotadura
Suavizado = 100;        //[40:4:160]


///////////////////////////////////Parámetros fijos///////////////////////////////////

/* [Hidden] */

Redondeo = 4;

RadCuerpo = 250;

RadioBase = (GrosMaxInf)/2;

Calc = RadCuerpo-(AnchoTotal-((RadCuerpo+AnchoTotal/2+AnchoTotal/8)-RadCuerpo));

Desplaz = ProfVol-RadioBase*3-(sqrt((RadCuerpo*RadCuerpo)-(Calc*Calc)));


///////////////////////////////////Módulos///////////////////////////////////




module Suavizado1() {
    rotate([90,90,0])
    translate([-RadCuerpo-AnchoTotal/2-AnchoTotal/8,Desplaz,-GrueSoMesa-GrueMesa-GrosMinInf-RadioBase+1])
        cylinder(GrueSoMesa+GrueMesa+GrosMinInf+RadioBase, r=RadCuerpo,$fn=Suavizado);
                    }




module Suavizado2() {
    rotate([90,90,0])
    translate([RadCuerpo-AnchoTotal/2+AnchoTotal/8,Desplaz,-GrueSoMesa-GrueMesa-GrosMinInf-RadioBase+1])
        cylinder(GrueSoMesa+GrueMesa+GrosMinInf+RadioBase, r=RadCuerpo,$fn=Suavizado);
                    }






module Base() {
    difference() {
        hull() {
            translate([ProfVol-Redondeo*2,0,0])
                cube([ProfTotal-ProfVol-Redondeo,GrueSoMesa+GrueMesa+GrosMinInf-Redondeo*2,AnchoTotal-Redondeo*2]);
            translate([0,Redondeo,0])
                cylinder(AnchoTotal-Redondeo*2, r=Redondeo,$fn=50);
            translate([ProfVol-RadioBase*2,GrueMesa+RadioBase/2,0])
                cylinder(AnchoTotal-Redondeo*2, r=RadioBase,$fn=50);
               }
        
    
        if(Escotadura=="Izquierda")
            Suavizado2();
               
        if(Escotadura=="Derecha")
            Suavizado1();
                

                  }
              }


module Principal() {
minkowski(){
Base();
sphere(r=Redondeo,$fn=20);
}
}

if(Borde=="Redondeado")
difference(){
Principal(); 
translate([ProfVol,GrueSoMesa-Redondeo,-Redondeo]) 
            cube([ProfTotal,GrueMesa,AnchoTotal+Redondeo*2]);
translate([ProfVol,GrueMesa/2+GrueSoMesa-Redondeo,-Redondeo])
            cylinder(AnchoTotal+Redondeo*2,d=GrueMesa,$fn=50);
}

if(Borde=="Plano")
difference(){
Principal(); 
translate([ProfVol-GrueMesa/2,GrueSoMesa-Redondeo,-Redondeo]) 
            cube([ProfTotal,GrueMesa,AnchoTotal+Redondeo*2]);
}




